.include "m16def.inc"
.device ATMEGA16


.dseg
cnt: .byte 4
count1: .byte 1
recv: .byte 8

.cseg
reset:			rjmp _init
nop
int_ext0:		reti
nop
int_ext1:		reti	
nop
int_ext2:		reti
nop
int_t2cmp:		reti
nop
int_t2ovr:		reti
nop
int_t1capt:		reti
nop
int_t1cmpa:		reti
nop
int_t1cmpb:		reti
nop
int_t1ovr:		reti
nop
int_t0ovr:		reti
nop
int_t0cmp:		reti
nop
int_spistc:		reti
nop
int_usart_rxc:	reti
nop
int_usart_udre:	reti
nop
int_usart_txc:	reti
nop
int_adc:		reti
nop
int_eerdy:		reti
nop
int_anacmp:		reti
nop
int_twi:		reti
nop
int_spmrdy:		reti
nop

.include "lcd4x16.inc"
.include "twi_master.inc"


_init:
; init stack
	ldi	r16,low(RAMEND)
	out	SPL,r16		; Set stack pointer to last internal RAM location
	ldi	r16,high(RAMEND)
	out	SPH,r16

	ldi	r16, 0xff
	out PORTA, r16	

	ldi	r16, 0xff
	out PORTB, r16	
  out DDRB, r16

	rcall _LCD_init_display

	ldi r20, 0b00001101
	rcall _lcd_write_cmd

	ldi r20, 0b10000001
	rcall _lcd_write_cmd


; init finished

clr r16
sts cnt+0, r16
sts cnt+1, r16
sts cnt+2, r16
sts cnt+3, r16
sts recv+0, r16
sts recv+1, r16
sts recv+2, r16
sts recv+3, r16
inc r16
sts count1, r16
clr r11


ldi r20, 0
ldi r21, 0
rcall _LCD_gotoxy
ldi r20, 0x2e
rcall _LCD_print_char


  ldi r20, 0
  ldi r21, 72
  rcall Twi_init_master



ldi r20, 0x2e
rcall _LCD_print_char


mainloop:

lds r6, cnt+0
lds r7, cnt+1
lds r8, cnt+2
lds r9, cnt+3
ldi r16, 1
ldi r17, 0
add r6, r16
adc r7, r17
adc r8, r17
adc r9, r17
sts cnt+0, r6
sts cnt+1, r7
sts cnt+2, r8
sts cnt+3, r9


    ldi r20, 4
    ldi r21, 0x40
    ;mov r21, r11
    inc r11
    ldi r30, LOW(recv)
    ldi r31, HIGH(recv)
    rcall Twi_read_byte
    mov r9, r20

;ldi r20, 0x2e
;rcall _LCD_print_char

;lds r16, count1
;dec r16
;sts count1, r16
;cpi r16, 0
;brne nolcd


ldi r16, 100
sts count1, r16


    ; Ausgabe, damit wir sehen was geschehen ist 
ldi r20, 0
ldi r21, 0
rcall _LCD_gotoxy
lds r20, cnt+0
lds r21, cnt+1
rcall _LCD_print_word
ldi r20, 6
ldi r21, 0
rcall _LCD_gotoxy
lds r20, cnt+2
lds r21, cnt+3
rcall _LCD_print_word

ldi r20, 0
ldi r21, 1
rcall _LCD_gotoxy
lds r20, recv+0
lds r21, recv+1
rcall _LCD_print_word
ldi r20, 6
ldi r21, 1
rcall _LCD_gotoxy
lds r20, recv+2
lds r21, recv+3
rcall _LCD_print_word
    
ldi r20, 0
ldi r21, 2
rcall _LCD_gotoxy
lds r20, twi_error
ldi r21, 0
rcall _LCD_print_word

ldi r20, 0
ldi r21, 3
rcall _LCD_gotoxy
lds r20, twi_status
ldi r21, 0
rcall _LCD_print_word
  
ldi r20, 10
ldi r21, 3
rcall _LCD_gotoxy
mov r20, r9
ldi r21, 0
rcall _LCD_print_word  


ldi r20, 8
ldi r21, 2
rcall _LCD_gotoxy
mov r20, r11
ldi r21, 0
rcall _LCD_print_word

    
nolcd:

    rjmp mainloop



